﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AudioTools
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        //---------------------------------------------------------------------
        //  フィールド
        //---------------------------------------------------------------------
        private System.Media.SoundPlayer _player = new System.Media.SoundPlayer();

        //---------------------------------------------------------------------
        //  コンストラクタ
        //---------------------------------------------------------------------
        public MainWindow()
        {
            InitializeComponent();
        }

        //---------------------------------------------------------------------
        //  イベント：再生ボタン クリック
        //---------------------------------------------------------------------
        private void playButton_Click(object sender, RoutedEventArgs e)
        {
            //  再生
            _player.Play();
        }

        //---------------------------------------------------------------------
        //  イベント：停止ボタン クリック
        //---------------------------------------------------------------------
        private void stopButton_Click(object sender, RoutedEventArgs e)
        {
            //  停止
            _player.Stop();
        }

        //---------------------------------------------------------------------
        //  イベント：開くボタン クリック
        //---------------------------------------------------------------------
        private void openButton_Click(object sender, RoutedEventArgs e)
        {
            //  ダイアログの作成
            Microsoft.Win32.OpenFileDialog dialog = new Microsoft.Win32.OpenFileDialog();
            dialog.Filter = "*.wav|*.wav";

            //  ダイアログを表示してファイルを選択
            if (dialog.ShowDialog() == true)
            {
                //  フォーマット情報の取得
                var info = WaveFormat.GetFormatInfo(dialog.FileName);
                if (info.IsValid)
                {
                    //  フォーマット情報を表示
                    formatTextBlock.Text =
                        dialog.FileName + Environment.NewLine +
                        info.Bit.ToString() + "bit  " +
                        info.SampleRate.ToString() + "Hz  " +
                        info.ChannelCount.ToString() + "Channel(s)" + Environment.NewLine +
                        info.Duration.ToString("0.00 sec");

                    //  サウンドファイルの指定
                    _player.SoundLocation = dialog.FileName;
                }
                else
                {
                    //  警告を表示
                    formatTextBlock.Text = "INVALID FORMAT !!";
                }
            }
        }
    }
}
